unit fMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NMURL, Psock, NMHttp, fUtils, Grids, Menus;

const
	RS_GRID_HEADER = 'N@X,W@,Ri,X,,^,q,}L,̰,̧C,^T,_T,Q,,^';
  DIR_DATA = 'DATA';
  DIR_WEB_SOURCE = DIR_DATA + '\SOURCE';
  FILENAME_STOCKLST = 'STOCK.LST';

type
  TfrmMain = class(TForm)
    http: TNMHTTP;
    GRID: TStringGrid;
    MainMenu1: TMainMenu;
    Setup1: TMenuItem;
    N1: TMenuItem;
    FontDialog1: TFontDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure GRIDDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormDestroy(Sender: TObject);
    procedure N1Click(Sender: TObject);
  protected
  	TSE: ISplitStrList;
    OTC: ISplitStrList;
    StockList: TStringList;
    GridHeader: ISplitStrList;
    procedure LoadStockData(List: TStringList; FileName: string);
    procedure SaveStockList(List: TStringList; FileName: string);
  	procedure GET_ALL_STOCK_INFO; overload;
    procedure UPDATE_ALL_STOCK_FROM_WEB;
    function 	EXTRACT_DATA_PASS_1(L: TStringList): Boolean;
    procedure FILL_GRID_OBJECT;
    procedure ITERATE_STOCK_DATA; overload;
    procedure ITERATE_STOCK_DATA(Row: Integer); overload;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses Math;

procedure TfrmMain.GET_ALL_STOCK_INFO;
var
  I, J: Integer;
	L: ISplitStrList;
  Sector: string;
begin
	http.InputFileMode := True;
	for I := 0 to 1 do
  begin
  	if I = 0 then L := TSE else L := OTC;
   	for J := 0 to L.sl.Count-1 do
    begin
 	    Sector := Trim(L.sl[J]);
   	  if Sector = '' then Continue;
      http.Body := 'Data\Source\'+ Sector +'.html';
 	    http.Get(RS_URL + Sector);
  	end;
  end;
end;

function TfrmMain.EXTRACT_DATA_PASS_1(L: TStringList): Boolean;
var
	I: Integer;
begin//uOdѲID, Name, H ƦCr

  //]Deleteʧ@,ҥHϥdownto for loop
	for I := L.Count-1 downto 0 do
		if _isStockIdName_(L[I]) or _isStockData_(L[I]) then Continue else L.Delete(I);
  //ثeCѲU11(tID, Name)
  Result := L.Count mod 11 = 0;

end;

procedure TfrmMain.LoadStockData(List: TStringList; FileName: string);
var
	I, Count, Index: Integer;
	Rec: TStockFileRec;
  M: TMemoryStream;
  O: TStock;
begin
	if FileExists(FileName) then
  begin
  	M := TMemoryStream.Create;
    M.LoadFromFile(FileName);
    Count := M.Size div SizeOf(Rec);
    for I := 0 to Count-1 do
    	if M.Read(Rec, SizeOf(Rec)) = SizeOf(Rec) then
      begin
      	O := TStock.Create(Rec);
        if not StockList.Find(O.Key,Index) then
        	Index := StockList.AddObject(O.Key,O)
        else begin
        	TStock(StockList.Objects[Index]).Rec := Rec;
          _free_(O);
        end;
      end;
  end;
end;

procedure TfrmMain.SaveStockList(List: TStringList; FileName: string);
var
	I: Integer;
	M: TMemoryStream;
begin
	M := TmemoryStream.Create;
  try
	  for I := 0 to StockList.Count-1 do
  		M.Write(TStock(StockList.Objects[I]).Rec, SizeOf(TStockFileRec));
  	M.SaveToFile(FileName);
  finally
	  _free_(M);
  end;
end;

procedure TfrmMain.UPDATE_ALL_STOCK_FROM_WEB;
var
	O: TStock;
  P: PStockFileRec;
  I, J, K, Index: Integer;
	L: ISplitStrList;
  M: TStringList;
begin
	for I := 0 to 1 do
  begin
  	if I = 0 then L := TSE else L := OTC;
    for J := 0 to L.sl.Count-1 do
    begin
			M := _create_(False,DIR_WEB_SOURCE+'\'+ L.sl[J] +'.html');
		  try
  			if not EXTRACT_DATA_PASS_1(M) then
    			raise Exception.Create('lɮ׮榡~!!!');
        P := nil;
        for K := 0 to M.Count-1 do
          case K mod 11 of
            0:begin
                if P <> nil then Dispose(P);
                if _isStockIDName_(M[K]) then
                begin
                  New(P);
                  P^.ID := _extractStkID_(M[K]);
                  P^.Name := _extractStkNAME_(M[K]);
                  P^.Market := I;
                  P^.Kind := J div 25;
                  P^.Sector := J;
                end;
              end;
            else if P <> nil then
              case K mod 11 of
                1: P^.DealTime := _extractDealTime_(M[K]);
                2: P^.Deal:= _extractDeal_(M[K]);
                3: P^.Bid := _extractValue_(M[K]);
                4: P^.Ask := _extractValue_(M[K]);
                5: P^.Diff:= _extractDiff_(M[K]);
                6: P^.VOL := _extractValue_(M[K]);
                7: P^.Ref := _extractValue_(M[K]);
                8: P^.Open:= _extractValue_(M[K]);
                9: P^.High:= _extractValue_(M[K]);
                10:	begin
                			P^.Low := _extractValue_(M[K]);
                      O := TStock.Create(P^);
                      if not StockList.Find(O.Key, Index) then
                      	Index := StockList.AddObject(O.Key, O)
                      else begin
	                      TStock(StockList.Objects[Index]).Rec := P^;
                        _free_(O);
                      end;
                		end;
              end;
          end;
  		finally
	  		_free_(M);
      end;
  	end;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
	if not DirectoryExists(DIR_DATA) then MkDir(DIR_DATA);
  if not DirectoryExists(DIR_WEB_SOURCE) then MkDir(DIR_WEB_SOURCE);
	TSE := _split_(RS_TSE_SECTOR);
  OTC := _split_(RS_OTC_SECTOR);
  GridHeader := _split_(RS_GRID_HEADER);
  StockList := _create_(True);
  if FileExists(DIR_DATA+'\'+FILENAME_STOCKLST) then
	  LoadStockData(StockList, DIR_DATA+'\'+FILENAME_STOCKLST)
  else begin
//  	GET_ALL_STOCK_INFO;
			{oӰʧ@|W[YAHOO_t,PHMark_,ϥήɽЦۦru,
      	lXlؿ.\DATAUƬOeDownload(2006-08-17)}
    UPDATE_ALL_STOCK_FROM_WEB;
  end;

	WindowState := wsMaximized;
  GRID.RowCount := Screen.Height div 24 - 1;
	FormResize(GRID);
  Self.FILL_GRID_OBJECT;
  ITERATE_STOCK_DATA;
  
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
	CalcColWidths(GRID);
	CalcFontHeight(GRID, 3.5);
//	GRID.DefaultRowHeight := Max(25,Round(GRID.Font.Height * 1.2));
end;

procedure TfrmMain.ITERATE_STOCK_DATA;
var
	Row: Integer;
begin
	for Row := 1 to GRID.RowCount-1 do ITERATE_STOCK_DATA(Row);
end;

procedure TfrmMain.ITERATE_STOCK_DATA(Row: Integer);
var
	Col: Integer;
  O: TStock;
begin
	if (Row > 0) and (Row < GRID.RowCount) then
  	if GRID.Objects[0,Row] <> nil then
	  begin
			O := TStock(GRID.Objects[0,Row]);
    	if O <> nil then
	    	for Col := 0 to GRID.ColCount-1 do
  	    	case Col of
    	    	0: GRID.Cells[Col, Row] := Trim(O.Rec.ID);
            1: GRID.Cells[Col, Row] := AdjustStkName(Trim(O.Rec.Name));
            2: GRID.Cells[Col, Row] := _vs_(O.Rec.Bid);
            3: GRID.Cells[Col, Row] := _vs_(O.Rec.Ask);
            4: GRID.Cells[Col, Row] := _vs_(O.Rec.Deal);
            5: GRID.Cells[Col, Row] := _vs_(O.Rec.Diff,2,False,True);
            6: GRID.Cells[Col, Row] := _vs_(O.Rec.VOL,0);
            7: GRID.Cells[Col, Row] := _vs_(O.Rec.Open);
            8: GRID.Cells[Col, Row] := _vs_(O.Rec.High);
            9: GRID.Cells[Col, Row] := _vs_(O.Rec.Low);
            10:GRID.Cells[Col, Row] := _vs_(O.DiffPercentage,2,False,True);
            11:GRID.Cells[Col, Row] := _vs_(O.HiLoRange);
            12:GRID.Cells[Col, Row] := _vs_(O.Rec.Ref);
            13:GRID.Cells[Col, Row] := _vs_(O.Ceil,2,False,True);
            14:GRID.Cells[Col, Row] := _vs_(-O.Floor,2,False,True);
          end;
    end;
end;

procedure TfrmMain.FILL_GRID_OBJECT;
var
	I: Integer;
begin
	if StockList.Count = 0 then
  begin
  	GRID.RowCount := 2;
    GRID.Objects[0,1] := nil;
  end
  else GRID.RowCount := StockList.Count+1;

  for I := 0 to StockList.Count-1 do
  	if StockList.Objects[I] <> nil then
    	GRID.Objects[0,I+1] := StockList.Objects[I];
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
	SaveStockList(StockList,DIR_DATA+'\'+FILENAME_STOCKLST);
	_free_(StockList, True);
end;

procedure TfrmMain.GRIDDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
	Q: TTextRectInfo;
  O: TStock;
  V: Single;
begin
 	Q := _rec_(Rect,'',clBlack,clBtnFace,taCenter,tlCenter);
  if ARow = 0 then Q.S := GridHeader.sl[ACol]
  else begin
    Q.S := GRID.Cells[ACol,ARow];
    Q.FC := clBlack;
    Q.BC := GRID.Color;
    Q.AL := taRightJustify;
  	O := TStock(GRID.Objects[0,ARow]);//ΥHP_C
    if O <> nil then
    begin
	    case ACol of
      	2: V := O.Rec.Bid;
        3: V := O.Rec.Ask;
        4: V := O.Rec.Deal;
        5: V := O.Rec.Deal;
        7: V := O.Rec.Open;
        8: V := O.Rec.High;
        9: V := O.Rec.Low;
        10:V := O.Rec.Deal;
        12:V := O.Rec.Ref;
        13:V := O.Ceil;
        14:V := O.Floor;
        else begin
        	V := 0;
          case ACol of
          	0,1:begin
            			if O.Rec.Market = 0 then Q.FC := clBlue else Q.FC := clOlive;
                  Q.BC := clBtnFace;
            		end;
            6: 	Q.FC := clTeal;
            11: Q.FC := clNavy;
          end;
        end;
      end;
      if V > 0 then
      begin
      	Q.FC := O.psFC(V);
        Q.BC := O.psBC(V);
      	if Q.S <> '' then
        begin
	        			if (O.PriceState(V) = psCeil) 	and not (Q.S[1] in ['+','-']) then Q.S := '+' + Q.S
  	      else 	if (O.PriceState(V) = psFloor) 	and not (Q.S[1] in ['+','-']) then Q.S := '-' + Q.S;
        end;
      end;
    end;
    if ACol in [0,1] then Q.AL := taLeftJustify;
	end;
  with Q do _textRect_(GRID.Canvas,R,S,FC,BC,AL,TL,Transparent);
end;

procedure TfrmMain.N1Click(Sender: TObject);
begin
	TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
  IS_FRACTION_UNDERLINE := TMenuItem(Sender).Checked;
  GRID.Invalidate;
end;

end.
