unit fUtils;

interface

uses Windows, Classes, Graphics, StdCtrls, Grids;

const

	RS_URL = 'http://tw.stock.yahoo.com/s/list.php?c='; //TSE: 25,26v,27q; OTC: 25v; 26q

  RS_TSE_SECTOR = 'd,~,콦,´@,´G,q,qql,Ƥu,,y,K,,T,'						+
  								'ql@,qlG,qlT,ql|,ql,ql,,B,[,Ĥ@&c=ĤG,Tʳf,'	+
                  'L,,vҤ@&c=vҤG&c=vҤT&c=vҥ|&c=vҤ&c=vҤ,qŤ@&c=qŤG&c=qŤT';

	RS_OTC_SECTOR = 'dͧ,d~,d콦,d´,dq,dq,dƤu,d,dqT,dK,d,dn,dql@,'	+
  								'dqlG,dqlT,dql|,dql,d,dB,d[,d,dT,dҨ,d޲z,dL,'	+
                  'dv,dqŤ@&c=dqŤG&c=dqŤT&c=dqť|&c=dqŤ&c=dqŤ';

var
	FONT_CHINESE: string = 'з';
  FONT_DIGIT  : string = 'ARIAL';
  IS_FRACTION_UNDERLINE: Boolean = False;
  IS_CHINESE_AUTOCOLOR: Boolean = False;

type
	TMAS_Procedure 		= procedure;
  TMAS_ProcEvent 		= procedure of object;

{ TTextRectInfo }
  PMAS_TextRectInfo = ^TTextRectInfo;
	TTextRectInfo = packed record
    R: TRect;
    S: string;
    FC,BC: TColor;
    AL: TAlignment;   			//Alignment
    TL: TTextLayout;  			//Alignment
    Transparent	: Boolean;	//z
  end;

{ TCharSet }
	TCharSet = set of Char;
  
{ ISplitStrList }
	ISplitStrList = interface(IUnknown)
    function sl: TStringList;
  end;

{ TSplitStrList }
  TSplitStrList = class(TInterfacedObject, ISplitStrList)
  protected
  	L: TStringList;
    FClearObjectOnFree: Boolean;
    function sl: TStringList;
  public
		constructor Create(	CVS: string; Sorted: Boolean=False;
                        ClearObjectOnFree: Boolean=False);
    destructor Destroy; override;
  end;

{ TStockFileRec }
	PStockFileRec = ^TStockFileRec;
  TStockFileRec = packed record
		ID: string[7];
    Name: string[10];
    Market,Kind,Sector: Byte;
    DealTime: TDateTime;
    Ref,Bid,Ask,Deal,Diff,Open,High,Low,Vol: Single;
	  end;

{ TPriceState }
	TPriceState = (psCeil, psUp, psEven, psDown, psFloor, psNonTrade);

{ TStock }
	TStock = class(TPersistent)
  private
  	function GetKey: string;
  	function GetID: string;   					//ѲNX
    function GetName: string;						//ѲW
  protected
  	FRec: TStockFileRec;
  public
  	constructor Create(Rec: TStockFileRec);
    function Ceil: Single;						//Ѧһ
    function Floor: Single;					//^Ѧһ
    function DiffPercentage: Single;
    function HiLoRange: Single;
		function DealState: TPriceState;
    function PriceState(Price: Single): TPriceState;
    function psFC(Price: Single): TColor;
    function psBC(Price: Single): TColor;
    property Key: string read GetKey;
    property ID: string read GetID;
    property Name: string read GetName;
    property Rec: TStockFileRec read FRec write FRec;
  end;

function 	_if_(B: Boolean; T,F: Single): Single; 										overload;
function 	_if_(B: Boolean; T,F: Integer): Integer; 									overload;
function 	_if_(B: Boolean; T,F: string): string; 										overload;
function 	_if_(B: Boolean; T,F: TObject): TObject; 									overload;
function 	_if_(B: Boolean; T,F: TDateTime): TDateTime; 							overload;
function 	_if_(B: Boolean; T,F: Boolean): Boolean; 									overload;
function 	_if_(B: Boolean; T,F: Pointer): Pointer; 									overload;
function 	_if_(B: Boolean; T,F: Int64): Int64; 											overload;
function 	_if_(B: Boolean; T,F: TRect): TRect; 											overload;
function 	_if_(B: Boolean; T,F: WORD): WORD; 		overload;
function 	_if_(B: Boolean; T,F: TAlignment): TAlignment; 						overload;
procedure _if_(B: Boolean; T: TMAS_ProcEvent; F: TMAS_ProcEvent); 	overload;
procedure _if_(B: Boolean; T: TMAS_Procedure; F: TMAS_Procedure); 	overload;
procedure _if_(B: Boolean; T: TMAS_ProcEvent; F: TMAS_Procedure); 	overload;
procedure _if_(B: Boolean; T: TMAS_Procedure; F: TMAS_ProcEvent); 	overload;

function  _rec_(R: TRect; S: string; FC: TColor=clWhite; BC: TColor=clBlack;
	AL: TAlignment=taCenter; TL: TTextLayout=tlCenter; Transparent: Boolean=False): TTextRectInfo;

procedure _clearObject_(List: TStringList); overload;
function  _create_(Sorted: Boolean): TStringList; overload;
function  _create_(Sorted: Boolean; FileName: string): TStringList; overload;
procedure _free_(var Obj); overload;
procedure _free_(List: TStringList; isClearObject: Boolean); overload;
function 	_split_(S, Delimiter: string): TStringList; overload;
function 	_split_(CVS: string): ISplitStrList; overload;
function  _toCVS_(S: string; CharSet: TCharSet): string;

//Extract Data from string
function _isStockIdName_(S: string): Boolean;
function _isStockData_(S: string): Boolean;
function _extract_IDNAME_(Src: string): string;
function _extractStkID_(Src: string): string;
function _extractStkNAME_(Src: string): string;
function _extractStkData_(Src: string; Head, Tail: string; Check: Boolean=True): string;
function _extractDealTime_(Src: string): TDateTime;
function _extractDeal_(Src: string): Single;
function _extractValue_(Src: string): Single;
function _extractDiff_(Src: string): Single;
function _format_(Precise:Integer): string;
function  _vs_(Value:Extended; Precise:Integer=2; ShowZero:Boolean=False; Signed:Boolean=False): string;
function 	_width_(const R: TRect): Integer; 
function 	_height_(const R: TRect): Integer;

procedure CalcColWidths(G: TStringGrid);
procedure CalcRowHeights(G: TStringGrid);
procedure CalcFontHeight(G:TStringGrid; ColWordLen: Single);
function AdjustStkName(S: string): string;
function ElimitBlankStr(S: string): string;
procedure _textRect_(Canvas: TCanvas; Rect: TRect; Str: string; fgColor: TColor=clWhite;
                     bgColor: TColor=clBlack; Alignment: TAlignment	=taCenter;
                     Layout: TTextLayout=tlCenter; Transparent: Boolean=False);

function  _textRect_fmt_(Alignment: TAlignment; Layout: TTextLayout=tlCenter): Cardinal;

procedure DRAW_UNDERLINE_ALIGNLEFT(		Canvas: TCanvas; Rect: TRect; Str: string; fgColor: TColor;
                                      bgColor: TColor; Alignment: TAlignment; Layout: TTextLayout);
procedure DRAW_UNDERLINE_ALIGNRIGHT(	Canvas: TCanvas; Rect: TRect; Str: string; fgColor: TColor;
                                      bgColor: TColor; Alignment: TAlignment; Layout: TTextLayout);
procedure DRAW_UNDERLINE_ALIGNCENTER(	Canvas: TCanvas; Rect: TRect; Str: string; fgColor: TColor;
                                      bgColor: TColor; Alignment: TAlignment; Layout: TTextLayout);

function RoundStkPrice(Price: Single; RoundUp: Boolean = True): Single;

const
	FILTER_KEY_STKIDNAME = '<td align=center bgcolor=#FFFfff nowrap><a href=/q/q_';
  FILTER_KEY_STKDATA   = '<td align="center" bgcolor="#FFFfff" nowrap>';
//TPriceState = (psCeil, psUp, psEven, psDown, psFloor, psNonTrade);
  PSFC_COLOR: array[TPriceState] of TColor = (clYellow,clRed,clBlack,clGreen,clWhite,clBlack);
  PSBC_COLOR: array[TPriceState] of TColor = (clRed,clBtnFace,clBtnFace,clBtnFace,clGreen,clBtnFace);

implementation

uses SysUtils, Math;

{ TSplitStrList }

constructor TSplitStrList.Create(CVS: string; Sorted: Boolean; ClearObjectOnFree: Boolean);
begin
	inherited Create;
  FClearObjectOnFree := ClearObjectOnFree;
	L := _split_(CVS,',');
  if Sorted then L.Sorted := True;
end;

destructor 	TSplitStrList.Destroy;
begin
	_free_(L,FClearObjectOnFree);
	inherited;
end;

function TSplitStrList.sl: TStringList;
begin
	Result := L;
end;

procedure _free_(List: TStringList; isClearObject: Boolean);
begin
	if isClearObject then
  	_clearObject_(List);
  _free_(List);
end;

procedure CalcColWidths(G: TStringGrid);
begin
	with G do DefaultColWidth := (ClientWidth - 14) div ColCount;
end;

procedure CalcRowHeights(G: TStringGrid);
var
	M: Integer;
begin
	with G do
  begin
		DefaultRowHeight := ClientHeight div RowCount;
	  M := ClientHeight mod RowCount;
  	while M > 0 do
    begin
    	RowHeights[M-1] := RowHeights[M-1] + 1;
    	Dec(M);
    end;
    Update;
  end;
end;

procedure CalcFontHeight(G:TStringGrid; ColWordLen: Single);
begin
	G.Font.Height := ABS(Min(G.DefaultRowHeight-2,Round(G.DefaultColWidth/ColWordLen)-1));
end;

function  _if_(B: Boolean; T,F: Single): Single;									begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: Integer): Integer;								begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: Int64): Int64;										begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: Pointer): Pointer;								begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: string): string;									begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: TObject): TObject;								begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: Boolean): Boolean;								begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: TDateTime): TDateTime;						begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: TRect): TRect;										begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: WORD): WORD;											begin	if B then Result := T else Result := F;	end;
function  _if_(B: Boolean; T,F: TAlignment): TAlignment;					begin	if B then Result := T else Result := F;	end;
procedure _if_(B: Boolean; T: TMAS_ProcEvent; F: TMAS_ProcEvent);	begin	if B and Assigned(T)then(T) else if not B and Assigned(F)then(F);end;
procedure _if_(B: Boolean; T: TMAS_Procedure; F: TMAS_Procedure);	begin if B and Assigned(T)then(T) else if not B and Assigned(F)then(F);end;
procedure _if_(B: Boolean; T: TMAS_ProcEvent; F: TMAS_Procedure); begin if B and Assigned(T)then(T) else if not B and Assigned(F)then(F);end;
procedure _if_(B: Boolean; T: TMAS_Procedure; F: TMAS_ProcEvent); begin if B and Assigned(T)then(T) else if not B and Assigned(F)then(F);end;
function 	_width_(const R: TRect): Integer; 	begin Result := Max(0,R.Right-R.Left); 	end;
function 	_height_(const R: TRect): Integer;	begin	Result := Max(0,R.Bottom-R.Top); 	end;


procedure _free_(var Obj);
begin
	if TObject(Obj) <> nil then
  	FreeAndNil(Obj)
  else Pointer(Obj) := nil;
end;

function _split_(S,Delimiter: string): TStringList;
begin
	Result := TStringList.Create;
  Result.Text := StringReplace(S,Delimiter,#13,[rfReplaceAll,rfIgnoreCase]);
end;

function _split_(CVS: string): ISplitStrList;
begin
	Result := TSplitStrList.Create(CVS);
end;

procedure _clearObject_(List: TStringList);
var
	I: Integer;
begin
	if List = nil then Exit;
  for I := 0 to List.Count-1 do
    if List.Objects[I] <> nil then
      List.Objects[I].Free;
  List.Clear;
end;

function 	_create_(Sorted: Boolean): TStringList;
begin
	Result := TStringList.Create;
  if Sorted then
  begin
  	Result.Duplicates := dupIgnore;
    Result.Sorted := Sorted;
  end;
end;

function  _create_(Sorted: Boolean; FileName: string): TStringList;
begin
	Result := _create_(Sorted);
  if FileExists(FileName) then
  	Result.LoadFromFile(FileName);
end;

function _toCVS_(S: string; CharSet: TCharSet): string;
var
	I: Integer;
begin
	Result := S;
	for I := 1 to Length(Result) do
  	if Result[I] in CharSet then Result[I] := ',';
end;

function _isStockIdName_(S: string): Boolean;
begin
	Result := Pos(FILTER_KEY_STKIDNAME, S) > 0;
end;

function _isStockData_(S: string): Boolean;
begin
	Result := Pos(FILTER_KEY_STKDATA, S) > 0;
end;

function _extract_IDNAME_(Src: string): string;
var
	I, J: Integer;
begin
	Result := '';
  I := Pos('.html',Src);
  J := Pos('</a>',Src);
  if I * J > 0 then
  	Result := Trim(Copy(Src,I+6,J-I-5));
end;

function _extractStkID_(Src: string): string;
var
	I: Integer;
begin
	Result := '';
	Src := _extract_IDNAME_(Src);
	I := Pos(#$20,Src);
  if I > 0 then Result := Trim(Copy(Src,1,I-1));
end;

function _extractStkNAME_(Src: string): string;
var
	I: Integer;
begin
	Result := '';
	Src := _extract_IDNAME_(Src);
	I := Pos(#$20,Src);
  if I > 0 then Result := Trim(Copy(Src,I+1,Length(Src)-I-1));
end;

function _extractStkData_(Src: string; Head, Tail: string; Check: Boolean): string;
var
	I, J, Len: Integer;
begin
	Result := '';
	I := Pos(Head, Src);
 	J := Pos(Tail, Src);
  if I * J > 0 then
  begin
  	Len := Length(Head);
  	Src := Trim(Copy(Src,I+Len,J-I-Len));
    if not Check then Result := Src
    else
    	for I := 1 to Length(Src) do
    		if Src[I] in ['0'..'9','.',':'] then
      		Result := Result + Src[I];
  end;
end;

function _extractDealTime_(Src: string): TDateTime;
begin
	Result := 0;
	Src := _extractStkData_(Src,FILTER_KEY_STKDATA,'</td>');
  if (Src <> '') and (Src <> '') then
  begin
  	Src := Src + ':00';
    Result := Int(Now) + Frac(StrToDateTime(Src));
  end;
end;

function _extractDeal_(Src: string): Single;
begin
	Result := 0;
	Src := _extractStkData_(Src,FILTER_KEY_STKDATA+'<b>','</b></td>');
  if (Src <> '') and (Src <> '') then
    Result := StrToFloat(Src);
end;

function _extractValue_(Src: string): Single;
begin
	Result := 0;
	Src := _extractStkData_(Src,FILTER_KEY_STKDATA,'</td>');
  if (Src <> '') and (Src <> '') then
    Result := StrToFloat(Src);
end;

function _extractDiff_(Src: string): Single;
begin
	Result := 0;
	Src := _extractStkData_(Src,FILTER_KEY_STKDATA+'<font color=','</font></td>',False);
  Src := Copy(Src,9,Length(Src)-8);
  if (Src <> '') and (Src <> '') then
  begin
  				if Pos('',Src) > 0 then Src := Copy(Src,3,Length(Src)-2)
  	else  if Pos('',Src) > 0 then Src := Copy(Src,3,Length(Src)-2)
    else 	if Pos('',Src) > 0 then Src := '-' + Copy(Src,3,Length(Src)-2)
    else 	if Pos('',Src) > 0 then Src := '-' + Copy(Src,3,Length(Src)-2);
    Result := StrToFloat(Src);
  end;
end;

{ TStock }

constructor TStock.Create(Rec: TStockFileRec);
begin
	inherited Create;
  FRec := Rec;
end;

function TStock.getKey: string;
begin
	with FRec do Result := Format('%2.2d%2.2d%2.2d%6s', [Market,Kind,Sector,Trim(ID)]);// Ҷ
end;

function TStock.Ceil: Single; 	begin Result := RoundStkPrice(FRec.Ref * 1.07,False);	end;
function TStock.Floor: Single; 	begin Result := RoundStkPrice(FRec.Ref * 0.93); 			end;
function TStock.GetID: string;	begin Result := Trim(FRec.ID); 	 end;
function TStock.GetName: string;begin Result := Trim(FRec.Name); end;

function AdjustStkName(S: string): string;
begin
  if Pos(' ',S) > 0 then S := ElimitBlankStr(S);
  if Length(S) = 4 then Result := Copy(S,1,2) + '@' + Copy(S,3,2) else Result := S;
end;

function ElimitBlankStr(S: string): string;
var
	I: Integer;
begin
  Result := '';
  for I := 1 to Length(S) do
  	if S[I] <> #$20 then Result := Result + S[I];
end;

function _format_(Precise:Integer): string;
begin
	Result := '%.'+IntToStr(Precise)+'f';
end;

function  _vs_(Value:Extended; Precise:Integer; ShowZero, Signed:Boolean): string;
begin
	Result:='';
	if (Value=0) and (not ShowZero) then Exit;
	Result:=Format(_format_(Precise),[Value]);
  if Signed and (Value>0) then Result:='+'+Result;
end;


function TStock.DiffPercentage: Single;
begin
  if FRec.Ref > 0 then
  	Result := FRec.Diff / FRec.Ref * 100
  else Result := 0;
end;

function TStock.HiLoRange: Single;
begin
	if (FRec.Low > 0) and (FRec.High > FRec.Low) then
  	Result := FRec.High / FRec.Low * 100 - 100
  else Result := 0;
end;

procedure _textRect_(Canvas: TCanvas; Rect: TRect; Str: string; fgColor, bgColor: TColor;
										 Alignment: TAlignment; Layout: TTextLayout; Transparent: Boolean);
var
	IsChinese: Boolean;
	I, OFH: Integer;
begin
  OFH := Canvas.Font.Height;
  try
    Canvas.Font.Color := fgColor;
    Canvas.Brush.Color := bgColor;

    IsChinese := False;
    if (Str='') or (Str='.') or (Str='') or (Str='') or (Str='.') then
      Canvas.Font.Name := 'ARIAL'
    else begin
      I := 1;
      while I < Length(Str) do
      begin
        IsChinese := Ord(Str[I]) > 127;
        if IsChinese then Break;
        Inc(I);
      end;
      Canvas.Font.Name := _if_(IsChinese,FONT_CHINESE,FONT_DIGIT);
    end;

    if(not Transparent)then Canvas.FillRect(Rect);

    if IS_CHINESE_AUTOCOLOR and IsChinese then begin{}end
    else if IS_FRACTION_UNDERLINE and not IsChinese then
    begin
    	Canvas.Font.Style := Canvas.Font.Style + [fsBold];
      case Alignment of
        taLeftJustify	: DRAW_UNDERLINE_ALIGNLEFT(Canvas,Rect,Str,fgColor,bgColor,Alignment,Layout);
        taRightJustify: DRAW_UNDERLINE_ALIGNRIGHT(Canvas,Rect,Str,fgColor,bgColor,Alignment,Layout);
        else            DRAW_UNDERLINE_ALIGNCENTER(Canvas,Rect,Str,fgColor,bgColor,Alignment,Layout);
      end;
    end
    else DrawText(Canvas.Handle,PChar(Str),-1,Rect,_textRect_fmt_(Alignment,Layout));

  finally
    Canvas.Font.Height := OFH;
  end;
end;

function  _textRect_fmt_(Alignment: TAlignment; Layout: TTextLayout=tlCenter): Cardinal;
begin
  Result := DT_SINGLELINE;
  case(Alignment)of
    taLeftJustify	: Result := Result or DT_LEFT;
    taRightJustify: Result := Result or DT_RIGHT;
    else 						Result := Result or DT_CENTER;
  end;
  case(Layout)of
    tlTop		: Result := Result or DT_TOP;
    tlBottom: Result := Result or DT_BOTTOM;
    else 			Result := Result or DT_VCENTER;
  end;
end;

procedure DRAW_UNDERLINE_ALIGNLEFT(		Canvas: TCanvas; Rect: TRect; Str: string; fgColor: TColor;
                                      bgColor: TColor; Alignment: TAlignment; Layout: TTextLayout);
var
	I, OFH: Integer;
  S1,S2,S3: string;
  R1,R2,R3,TR: TRect;
begin
	OFH := Canvas.Font.Height;
  I := Pos('.', Str);
  if I < 1 then DrawText(Canvas.Handle,PChar(Str),-1,Rect,_textRect_fmt_(Alignment,Layout))
  else begin
    S1 := Copy(Str,1,I-1);
    S2 := Copy(Str,I+1,Length(Str)-I);
    S3 := '';
    with Canvas, Rect do R1 := Classes.Rect(Left,Top,Left+TextWidth(S1),Bottom);
    SubtractRect(R2, Rect, R1);
    Canvas.Font.Height := OFH * 9 div 10;
    if (Length(S2)>1) and (S2[Length(S2)]in['%']) then
    begin
      S2 := Copy(S2,1,Length(S2)-1);
      S3 := '%';
      TR := R2;
      with Canvas, TR do R2 := Classes.Rect(Left,Top,Left+TextWidth(S2),Bottom);
      SubtractRect(R3, TR, R2);
    end;

    R2.Bottom := R2.Bottom - 3;

    for I := 1 to 3 do
    begin
      Canvas.Font.Style := Canvas.Font.Style - [fsUnderLine];
      if I = 2 then Canvas.Font.Style := Canvas.Font.Style + [fsUnderLine];
      Canvas.Font.Height := _if_(I in [2,3],OFH * 9 div 10,OFH);
      case I of
        1: DrawText(Canvas.Handle,PChar(S1),-1,R1,_textRect_fmt_(Alignment,Layout));
        2: DrawText(Canvas.Handle,PChar(S2),-1,R2,_textRect_fmt_(Alignment,Layout));
        3: if S3 <> '' then DrawText(Canvas.Handle,PChar(S3),-1,R3,_textRect_fmt_(Alignment,Layout));
      end;
    end;
  end;
end;

procedure DRAW_UNDERLINE_ALIGNRIGHT(	Canvas: TCanvas; Rect: TRect; Str: string; fgColor: TColor;
                                      bgColor: TColor; Alignment: TAlignment; Layout: TTextLayout);
var
	I, OFH: Integer;
  S1,S2,S3: string;
  R1,R2,R3: TRect;
begin
	OFH := Canvas.Font.Height;
  I := Pos('.', Str);
  if I < 1 then DrawText(Canvas.Handle,PChar(Str),-1,Rect,_textRect_fmt_(Alignment,Layout))
  else begin
    S1 := Copy(Str,1,I-1);
    S2 := Copy(Str,I+1,Length(Str)-I);
    S3 := '';
    Canvas.Font.Height := OFH * 9 div 10;
    with Canvas, Rect do R2 := Classes.Rect(Left+_width_(Rect)-TextWidth(S2),Top,Right,Bottom);
    SubtractRect(R1, Rect, R2);
    if (Length(S2)>1) and (S2[Length(S2)]in['%']) then
    begin
      S2 := Copy(S2,1,Length(S2)-1);
			S3 := '%';
      with Canvas, R2 do R3 := Classes.Rect(Left+_width_(R2)-TextWidth(S3),Top,Right,Bottom);
      SubtractRect(R2, R2, R3);
    end;

    R2.Bottom := R2.Bottom - 3;

    for I := 1 to 3 do
    begin
      Canvas.Font.Style := Canvas.Font.Style - [fsUnderLine];
      if I = 2 then Canvas.Font.Style := Canvas.Font.Style + [fsUnderLine];
      Canvas.Font.Height := _if_(I in [2,3],OFH * 9 div 10,OFH);
      case I of
        1: DrawText(Canvas.Handle,PChar(S1),-1,R1,_textRect_fmt_(Alignment,Layout));
        2: DrawText(Canvas.Handle,PChar(S2),-1,R2,_textRect_fmt_(Alignment,Layout));
        3: if S3 <> '' then DrawText(Canvas.Handle,PChar(S3),-1,R3,_textRect_fmt_(Alignment,Layout));
      end;
    end;
  end;
end;

procedure DRAW_UNDERLINE_ALIGNCENTER(	Canvas: TCanvas; Rect: TRect; Str: string; fgColor: TColor;
                                      bgColor: TColor; Alignment: TAlignment; Layout: TTextLayout);
var
	I, OFH: Integer;
  S1,S2,S3: string;
  R1,R2,R3,TR: TRect;
begin
	OFH := Canvas.Font.Height;
  I := Pos('.', Str);
  if I < 1 then DrawText(Canvas.Handle,PChar(Str),-1,Rect,_textRect_fmt_(Alignment,Layout))
  else begin
    S1 := Copy(Str,1,I-1);
    S2 := Copy(Str,I+1,Length(Str)-I);
    S3 := '';
    R1 := Rect;
    R2 := Rect;
    if (Length(S1) + Length(S2)) > 0 then R1.Right := R1.Left + Round(_width_(Rect) * Length(S1) / (Length(S1) + Length(S2)));
    R2.Left := R1.Left + _width_(R1);
    R2.Right := R2.Left + _width_(Rect) - _width_(R1);
    Canvas.Font.Height := OFH * 9 div 10;
    if (Length(S2)>1) and (S2[Length(S2)]in['%']) then
    begin
      S2 := Copy(S2,1,Length(S2)-1);
      S3 := '%';
      TR := R2;
      with Canvas, TR do R2 := Classes.Rect(Left,Top,Left+TextWidth(S2),Bottom);
      SubtractRect(R3, TR, R2);
    end;

   R2.Bottom := R2.Bottom - 3;

   for I := 1 to 3 do
    begin
      Canvas.Font.Style := Canvas.Font.Style - [fsUnderLine];
      if I = 2 then Canvas.Font.Style := Canvas.Font.Style + [fsUnderLine];
      Canvas.Font.Height := _if_(I in [2,3],OFH * 9 div 10,OFH);
      case I of
        1: DrawText(Canvas.Handle,PChar(S1),-1,R1,_textRect_fmt_(taRightJustify,Layout));
        2: DrawText(Canvas.Handle,PChar(S2),-1,R2,_textRect_fmt_(taLeftJustify,Layout));
        3: if S3 <> '' then DrawText(Canvas.Handle,PChar(S3),-1,R3,_textRect_fmt_(taLeftJustify,Layout));
      end;
    end;
  end;
end;

function  _rec_(R: TRect; S: string; FC,BC: TColor; AL: TAlignment;
	TL: TTextLayout; Transparent: Boolean): TTextRectInfo;
begin
	Result.R 	:= R;
  Result.S 	:= S;
  Result.FC := FC;
  Result.BC := BC;
  Result.AL := AL;
  Result.TL := TL;
  Result.Transparent := Transparent;
end;

function RoundStkPrice(Price: Single; RoundUp: Boolean): Single;
	function DoRound(Price: Single; RoundUp: Boolean; Precise: Single=0.01): Single;
  begin
  	Result := 0;
    if Precise > 0 then
    begin
	  	if RoundUp then Result := Round((Price + Precise / 2)/Precise) * Precise
  	  else Result := Trunc(Price / Precise) * Precise;
    end;
  end;
begin
				if Price < 10 	then Result := DoRound(Price,RoundUp,0.01)
  else 	if Price < 50 	then Result := DoRound(Price,RoundUp,0.05)
  else 	if Price < 100 	then Result := DoRound(Price,RoundUp,0.1)
  else 	if Price < 500 	then Result := DoRound(Price,RoundUp,0.5)
  else 	if Price < 1000 then Result := DoRound(Price,RoundUp,1)
  else Result := DoRound(Price,RoundUp,5)
end;
    

function TStock.DealState: TPriceState;
begin
	Result := PriceState(FRec.Deal);
end;

function TStock.PriceState(Price: Single): TPriceState;
begin
				if Price * FRec.Ref = 0 	then 	Result := psNonTrade
	else	if (Ceil = Floor)         then  Result := psNonTrade
  else 	if Price > (Ceil-0.0001)	then 	Result := psCeil
  else 	if Price < (Floor+0.0001)	then 	Result := psFloor
  else 	if Price > FRec.Ref 			then 	Result := psUp
  else 	if Price < FRec.Ref 			then 	Result := psDown
  else 																	Result := psEven;
end;

function TStock.psBC(Price: Single): TColor;
begin
	Result := PSBC_COLOR[PriceState(Price)];
end;

function TStock.psFC(Price: Single): TColor;
begin
	Result := PSFC_COLOR[PriceState(Price)];
end;

end.
